> ## Documentation Index
> Fetch the complete documentation index at: https://docs.getprimo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List software on a device

> Return the paginated list of software installed on a device. Supports filtering by vulnerability status, CVSS score range, install availability, and more.

<span className="badge-read">Key: Read</span><span className="badge-company">Scope: Company</span>


## OpenAPI

````yaml https://api.getprimo.com/openapi.json get /devices/{deviceId}/software
openapi: 3.1.1
info:
  title: Public API - BETA
  description: Read docs on https://docs.getprimo.com/
  version: '1.0'
  contact: {}
servers:
  - url: https://api.getprimo.com
security:
  - apikey: []
tags: []
paths:
  /devices/{deviceId}/software:
    get:
      tags:
        - Devices
      summary: List software on a device
      description: >-
        Return the paginated list of software installed on a device. Supports
        filtering by vulnerability status, CVSS score range, install
        availability, and more.
      operationId: getDeviceSoftware
      parameters:
        - name: deviceId
          required: true
          in: path
          schema:
            type: string
        - name: orderDirection
          required: false
          in: query
          description: Order direction
          schema:
            enum:
              - asc
              - desc
            type: string
        - name: orderKey
          required: false
          in: query
          description: Field to order results by
          schema:
            enum:
              - name
            type: string
        - name: maxCvssScore
          required: false
          in: query
          description: Maximum CVSS score (0-10)
          schema:
            type: number
        - name: minCvssScore
          required: false
          in: query
          description: Minimum CVSS score (0-10)
          schema:
            type: number
        - name: exploit
          required: false
          in: query
          description: Filter by known exploit availability
          schema:
            type: boolean
        - name: selfService
          required: false
          in: query
          description: Filter by self-service availability
          schema:
            type: boolean
        - name: includeAvailableForInstall
          required: false
          in: query
          description: Include software available for install in the results
          schema:
            type: boolean
        - name: availableForInstall
          required: false
          in: query
          description: Filter to software available for install
          schema:
            type: boolean
        - name: vulnerable
          required: false
          in: query
          description: Filter by vulnerability status
          schema:
            type: boolean
        - name: query
          required: false
          in: query
          description: Free-text search on the software name
          schema:
            type: string
        - name: page
          required: false
          in: query
          description: Page number
          schema:
            type: number
        - name: perPage
          required: false
          in: query
          description: Number of items per page (max 100)
          schema:
            type: number
      responses:
        default:
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetDeviceSoftware_Output'
components:
  schemas:
    GetDeviceSoftware_Output:
      type: object
      properties:
        data:
          type: array
          items:
            type: object
            properties:
              id:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
              name:
                anyOf:
                  - type: string
                  - type: 'null'
              iconUrl:
                anyOf:
                  - type: string
                  - type: 'null'
              source:
                anyOf:
                  - type: string
                  - type: 'null'
              extensionFor:
                anyOf:
                  - type: string
                  - type: 'null'
              status:
                anyOf:
                  - type: string
                  - type: 'null'
              installedVersions:
                anyOf:
                  - type: array
                    items:
                      type: object
                      properties:
                        version:
                          anyOf:
                            - type: string
                            - type: 'null'
                        bundleIdentifier:
                          anyOf:
                            - type: string
                            - type: 'null'
                        vulnerabilities:
                          anyOf:
                            - type: array
                              items:
                                type: string
                            - type: 'null'
                        installedPaths:
                          anyOf:
                            - type: array
                              items:
                                type: string
                            - type: 'null'
                        signatureInformation:
                          anyOf:
                            - type: array
                              items:
                                type: object
                                propertyNames:
                                  type: string
                                additionalProperties: {}
                            - type: 'null'
                        lastOpenedAt:
                          anyOf:
                            - type: string
                            - type: 'null'
                      required:
                        - version
                        - bundleIdentifier
                        - vulnerabilities
                        - installedPaths
                        - signatureInformation
                        - lastOpenedAt
                      additionalProperties: false
                  - type: 'null'
              displayName:
                anyOf:
                  - type: string
                  - type: 'null'
              softwarePackage:
                anyOf:
                  - type: object
                    propertyNames:
                      type: string
                    additionalProperties: {}
                  - type: 'null'
              appStoreApp:
                anyOf:
                  - type: object
                    propertyNames:
                      type: string
                    additionalProperties: {}
                  - type: 'null'
            required:
              - id
              - name
              - iconUrl
              - source
              - extensionFor
              - status
              - installedVersions
              - displayName
              - softwarePackage
              - appStoreApp
            additionalProperties: false
        pagination:
          type: object
          properties:
            page:
              type: integer
              minimum: 1
              maximum: 9007199254740991
            perPage:
              type: integer
              minimum: 1
              maximum: 100
            hasNextPage:
              type: boolean
            hasPreviousPage:
              type: boolean
            totalElements:
              anyOf:
                - type: integer
                  minimum: 0
                  maximum: 9007199254740991
                - type: 'null'
          required:
            - page
            - perPage
            - hasNextPage
            - hasPreviousPage
            - totalElements
          additionalProperties: false
      required:
        - data
        - pagination
      additionalProperties: false
  securitySchemes:
    apikey:
      scheme: bearer
      bearerFormat: API key
      type: http
      description: >-
        Use your Primo API key in the Authorization header as `Bearer
        <API_KEY>`.

````